// Generated by IcedCoffeeScript 1.7.1-c
(function() {
  var E, GE, ST, TrackSubSubCommand, TrackWrapper, User, assertions, athrow, chain_err, colors, constants, db, deq, env, iced, keypull, log, make_esc, master_ring, prompt_yn, proof_type_to_string, proofs, session, unix_time, util, __iced_k, __iced_k_noop, _ref, _ref1, _ref2;

  iced = require('iced-runtime').iced;
  __iced_k = __iced_k_noop = function() {};

  db = require('./db').db;

  constants = require('./constants').constants;

  log = require('./log');

  proofs = require('keybase-proofs');

  proof_type_to_string = proofs.proof_type_to_string;

  ST = constants.signature_types;

  deq = require('deep-equal');

  _ref = require('./err'), GE = _ref.GE, E = _ref.E;

  _ref1 = require('pgp-utils').util, athrow = _ref1.athrow, unix_time = _ref1.unix_time;

  _ref2 = require('iced-error'), chain_err = _ref2.chain_err, make_esc = _ref2.make_esc;

  prompt_yn = require('./prompter').prompt_yn;

  session = require('./session').session;

  User = require('./user').User;

  db = require('./db');

  util = require('util');

  env = require('./env').env;

  TrackWrapper = require('./trackwrapper').TrackWrapper;

  master_ring = require('./keyring').master_ring;

  assertions = require('./assertions');

  keypull = require('./keypull').keypull;

  colors = require('./colors');

  exports.TrackSubSubCommand = TrackSubSubCommand = (function() {
    TrackSubSubCommand.OPTS = {
      r: {
        alias: "track-remote",
        action: "storeTrue",
        help: "remotely track by default"
      },
      l: {
        alias: "track-local",
        action: "storeTrue",
        help: "don't prompt for remote tracking"
      },
      a: {
        action: 'append',
        alias: "assert",
        help: "provide a key assertion"
      },
      batch: {
        action: 'storeTrue',
        help: "batch-mode without interactivity"
      },
      "prompt-remote": {
        action: 'storeTrue',
        help: "prompt for remote tracking"
      }
    };

    function TrackSubSubCommand(_arg) {
      this.args = _arg.args, this.opts = _arg.opts, this.tmp_keyring = _arg.tmp_keyring, this.batch = _arg.batch, this.track_local = _arg.track_local, this.ran_keypull = _arg.ran_keypull;
      this.opts || (this.opts = {});
      this.qring = null;
    }

    TrackSubSubCommand.prototype.is_batch = function() {
      return this.opts.batch || this.batch;
    };

    TrackSubSubCommand.prototype.prompt_ok = function(warnings, proofs, cb) {
      var err, prompt, ret, them, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      them = this.args.them;
      prompt = warnings ? (log.console.error(colors.red("Some remote proofs failed!")), "Still verify this user as " + them + "?") : proofs === 0 ? "We found an account for " + them + ", but they haven't proved their identity. Still accept them?" : "Is this the " + them + " you wanted?";
      (function(_this) {
        return (function(__iced_k) {
          __iced_deferrals = new iced.Deferrals(__iced_k, {
            parent: ___iced_passed_deferral,
            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
            funcname: "TrackSubSubCommand.prompt_ok"
          });
          prompt_yn({
            prompt: prompt,
            defval: false
          }, __iced_deferrals.defer({
            assign_fn: (function() {
              return function() {
                err = arguments[0];
                return ret = arguments[1];
              };
            })(),
            lineno: 68
          }));
          __iced_deferrals._fulfill();
        });
      })(this)((function(_this) {
        return function() {
          return cb(err, ret);
        };
      })(this));
    };

    TrackSubSubCommand.prototype.prompt_track = function(proofs, cb) {
      var err, prompt, ret, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      ret = err = null;
      (function(_this) {
        return (function(__iced_k) {
          if (_this.opts.track_remote) {
            return __iced_k(ret = true);
          } else {
            (function(__iced_k) {
              if (_this.is_batch()) {
                return __iced_k(ret = false);
              } else {
                (function(__iced_k) {
                  if (!_this.me.have_secret_key()) {
                    return __iced_k(ret = false);
                  } else {
                    (function(__iced_k) {
                      if ((_this.opts.track_local || _this.track_local) && !_this.opts.prompt_remote) {
                        return __iced_k(ret = false);
                      } else {
                        prompt = "Permanently track this user, and write proof to server?";
                        (function(__iced_k) {
                          __iced_deferrals = new iced.Deferrals(__iced_k, {
                            parent: ___iced_passed_deferral,
                            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                            funcname: "TrackSubSubCommand.prompt_track"
                          });
                          prompt_yn({
                            prompt: prompt,
                            defval: true
                          }, __iced_deferrals.defer({
                            assign_fn: (function() {
                              return function() {
                                err = arguments[0];
                                return ret = arguments[1];
                              };
                            })(),
                            lineno: 85
                          }));
                          __iced_deferrals._fulfill();
                        })(__iced_k);
                      }
                    })(__iced_k);
                  }
                })(__iced_k);
              }
            })(__iced_k);
          }
        });
      })(this)((function(_this) {
        return function() {
          return cb(err, ret);
        };
      })(this));
    };

    TrackSubSubCommand.prototype.on_decrypt = function(cb) {
      var esc, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      esc = make_esc(cb, "TrackSubSub::on_decrypt");
      (function(_this) {
        return (function(__iced_k) {
          __iced_deferrals = new iced.Deferrals(__iced_k, {
            parent: ___iced_passed_deferral,
            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
            funcname: "TrackSubSubCommand.on_decrypt"
          });
          _this.keypull(esc(__iced_deferrals.defer({
            lineno: 92
          })));
          __iced_deferrals._fulfill();
        });
      })(this)((function(_this) {
        return function() {
          (function(__iced_k) {
            __iced_deferrals = new iced.Deferrals(__iced_k, {
              parent: ___iced_passed_deferral,
              filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
              funcname: "TrackSubSubCommand.on_decrypt"
            });
            User.load({
              username: _this.args.them
            }, esc(__iced_deferrals.defer({
              assign_fn: (function(__slot_1) {
                return function() {
                  return __slot_1.them = arguments[0];
                };
              })(_this),
              lineno: 93
            })));
            __iced_deferrals._fulfill();
          })(function() {
            _this.them.reference_public_key({
              keyring: _this.tmp_keyring
            });
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.on_decrypt"
              });
              User.load_me({
                maybe_secret: true
              }, esc(__iced_deferrals.defer({
                assign_fn: (function(__slot_1) {
                  return function() {
                    return __slot_1.me = arguments[0];
                  };
                })(_this),
                lineno: 95
              })));
              __iced_deferrals._fulfill();
            })(function() {
              (function(__iced_k) {
                __iced_deferrals = new iced.Deferrals(__iced_k, {
                  parent: ___iced_passed_deferral,
                  filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                  funcname: "TrackSubSubCommand.on_decrypt"
                });
                _this.check_not_self(esc(__iced_deferrals.defer({
                  lineno: 96
                })));
                __iced_deferrals._fulfill();
              })(function() {
                (function(__iced_k) {
                  __iced_deferrals = new iced.Deferrals(__iced_k, {
                    parent: ___iced_passed_deferral,
                    filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                    funcname: "TrackSubSubCommand.on_decrypt"
                  });
                  _this.them.verify({}, esc(__iced_deferrals.defer({
                    lineno: 97
                  })));
                  __iced_deferrals._fulfill();
                })(function() {
                  (function(__iced_k) {
                    __iced_deferrals = new iced.Deferrals(__iced_k, {
                      parent: ___iced_passed_deferral,
                      filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                      funcname: "TrackSubSubCommand.on_decrypt"
                    });
                    TrackWrapper.load({
                      tracker: _this.me,
                      trackee: _this.them
                    }, esc(__iced_deferrals.defer({
                      assign_fn: (function(__slot_1) {
                        return function() {
                          return __slot_1.trackw = arguments[0];
                        };
                      })(_this),
                      lineno: 98
                    })));
                    __iced_deferrals._fulfill();
                  })(function() {
                    return cb(null);
                  });
                });
              });
            });
          });
        };
      })(this));
    };

    TrackSubSubCommand.prototype.check_remote_proofs = function(skip, cb) {
      var err, esc, n_proofs, opts, warnings, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      esc = make_esc(cb, "TrackSubSub::check_remote_proofs");
      log.debug("+ TrackSubSub::check_remote_proofs");
      (function(_this) {
        return (function(__iced_k) {
          __iced_deferrals = new iced.Deferrals(__iced_k, {
            parent: ___iced_passed_deferral,
            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
            funcname: "TrackSubSubCommand.check_remote_proofs"
          });
          _this.parse_assertions(esc(__iced_deferrals.defer({
            lineno: 106
          })));
          __iced_deferrals._fulfill();
        });
      })(this)((function(_this) {
        return function() {
          opts = {
            skip: skip,
            assertions: _this.assertions
          };
          (function(__iced_k) {
            __iced_deferrals = new iced.Deferrals(__iced_k, {
              parent: ___iced_passed_deferral,
              filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
              funcname: "TrackSubSubCommand.check_remote_proofs"
            });
            _this.them.check_remote_proofs(opts, esc(__iced_deferrals.defer({
              assign_fn: (function() {
                return function() {
                  warnings = arguments[0];
                  return n_proofs = arguments[1];
                };
              })(),
              lineno: 108
            })));
            __iced_deferrals._fulfill();
          })(function() {
            err = null;
            if ((_this.assertions != null) && !(_this.assertions.check())) {
              err = new E.BadAssertionError();
            }
            log.debug("- TrackSubSub::check_remote_proofs -> " + (err != null ? err.message : void 0));
            return cb(err, warnings, n_proofs);
          });
        };
      })(this));
    };

    TrackSubSubCommand.prototype.qring_cleanup = function(cb) {
      var e, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      (function(_this) {
        return (function(__iced_k) {
          if (_this.qring != null) {
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.qring_cleanup"
              });
              _this.qring.nuke(__iced_deferrals.defer({
                assign_fn: (function() {
                  return function() {
                    return e = arguments[0];
                  };
                })(),
                lineno: 119
              }));
              __iced_deferrals._fulfill();
            })(function() {
              return __iced_k(typeof e !== "undefined" && e !== null ? log.warning("Error deleting quarantied keyring: " + e.message) : void 0);
            });
          } else {
            return __iced_k();
          }
        });
      })(this)((function(_this) {
        return function() {
          return cb();
        };
      })(this));
    };

    TrackSubSubCommand.prototype.make_quarantined_keyring = function(cb) {
      var err, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      (function(_this) {
        return (function(__iced_k) {
          __iced_deferrals = new iced.Deferrals(__iced_k, {
            parent: ___iced_passed_deferral,
            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
            funcname: "TrackSubSubCommand.make_quarantined_keyring"
          });
          _this.them.make_quarantined_keyring(__iced_deferrals.defer({
            assign_fn: (function(__slot_1) {
              return function() {
                err = arguments[0];
                return __slot_1.qring = arguments[1];
              };
            })(_this),
            lineno: 126
          }));
          __iced_deferrals._fulfill();
        });
      })(this)((function(_this) {
        return function() {
          return cb(err);
        };
      })(this));
    };

    TrackSubSubCommand.prototype.id = function(cb) {
      var accept, esc, warnings, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      cb = chain_err(cb, this.qring_cleanup.bind(this));
      esc = make_esc(cb, "TrackSubSub:id");
      log.debug("+ id");
      accept = false;
      (function(_this) {
        return (function(__iced_k) {
          __iced_deferrals = new iced.Deferrals(__iced_k, {
            parent: ___iced_passed_deferral,
            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
            funcname: "TrackSubSubCommand.id"
          });
          User.load({
            username: _this.args.them,
            require_public_key: true
          }, esc(__iced_deferrals.defer({
            assign_fn: (function(__slot_1) {
              return function() {
                return __slot_1.them = arguments[0];
              };
            })(_this),
            lineno: 136
          })));
          __iced_deferrals._fulfill();
        });
      })(this)((function(_this) {
        return function() {
          (function(__iced_k) {
            __iced_deferrals = new iced.Deferrals(__iced_k, {
              parent: ___iced_passed_deferral,
              filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
              funcname: "TrackSubSubCommand.id"
            });
            _this.make_quarantined_keyring(esc(__iced_deferrals.defer({
              lineno: 137
            })));
            __iced_deferrals._fulfill();
          })(function() {
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.id"
              });
              _this.them.verify({}, esc(__iced_deferrals.defer({
                lineno: 138
              })));
              __iced_deferrals._fulfill();
            })(function() {
              (function(__iced_k) {
                __iced_deferrals = new iced.Deferrals(__iced_k, {
                  parent: ___iced_passed_deferral,
                  filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                  funcname: "TrackSubSubCommand.id"
                });
                _this.check_remote_proofs(false, esc(__iced_deferrals.defer({
                  assign_fn: (function() {
                    return function() {
                      return warnings = arguments[0];
                    };
                  })(),
                  lineno: 139
                })));
                __iced_deferrals._fulfill();
              })(function() {
                (function(__iced_k) {
                  __iced_deferrals = new iced.Deferrals(__iced_k, {
                    parent: ___iced_passed_deferral,
                    filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                    funcname: "TrackSubSubCommand.id"
                  });
                  _this.them.display_cryptocurrency_addresses({}, esc(__iced_deferrals.defer({
                    lineno: 140
                  })));
                  __iced_deferrals._fulfill();
                })(function() {
                  log.debug("- id");
                  return cb(null);
                });
              });
            });
          });
        };
      })(this));
    };

    TrackSubSubCommand.prototype.pre_encrypt = function(cb) {
      var err, logged_in, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      (function(_this) {
        return (function(__iced_k) {
          if (!env().is_configured()) {
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.pre_encrypt"
              });
              _this.id(__iced_deferrals.defer({
                assign_fn: (function() {
                  return function() {
                    return err = arguments[0];
                  };
                })(),
                lineno: 148
              }));
              __iced_deferrals._fulfill();
            })(__iced_k);
          } else {
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.pre_encrypt"
              });
              session.load_and_check(__iced_deferrals.defer({
                assign_fn: (function() {
                  return function() {
                    err = arguments[0];
                    return logged_in = arguments[1];
                  };
                })(),
                lineno: 150
              }));
              __iced_deferrals._fulfill();
            })(function() {
              (function(__iced_k) {
                if (err == null) {
                  _this.skip_keypull = !logged_in;
                  _this.track_local = !logged_in;
                  (function(__iced_k) {
                    __iced_deferrals = new iced.Deferrals(__iced_k, {
                      parent: ___iced_passed_deferral,
                      filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                      funcname: "TrackSubSubCommand.pre_encrypt"
                    });
                    _this.run(__iced_deferrals.defer({
                      assign_fn: (function() {
                        return function() {
                          return err = arguments[0];
                        };
                      })(),
                      lineno: 154
                    }));
                    __iced_deferrals._fulfill();
                  })(__iced_k);
                } else {
                  return __iced_k();
                }
              })(__iced_k);
            });
          }
        });
      })(this)((function(_this) {
        return function() {
          return cb(err);
        };
      })(this));
    };

    TrackSubSubCommand.prototype.parse_assertions = function(cb) {
      var a, err, _ref3;
      err = null;
      if ((a = this.opts.assert) != null) {
        _ref3 = assertions.parse(a), err = _ref3[0], this.assertions = _ref3[1];
      }
      return cb(err);
    };

    TrackSubSubCommand.prototype.check_not_self = function(cb) {
      var err, t;
      err = null;
      if ((((t = this.args.them) != null) && (t === this.me.username())) || (((t = this.args.them_ki64) != null) && (t === this.me.key_id_64()))) {
        err = new E.SelfError("Cannot track yourself");
      }
      return cb(err);
    };

    TrackSubSubCommand.prototype.keypull = function(cb) {
      var err, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      err = null;
      (function(_this) {
        return (function(__iced_k) {
          if (!_this.ran_keypull && !_this.skip_keypull) {
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.keypull"
              });
              keypull({
                need_secret: false,
                stdin_blocked: _this.is_batch()
              }, __iced_deferrals.defer({
                assign_fn: (function() {
                  return function() {
                    return err = arguments[0];
                  };
                })(),
                lineno: 178
              }));
              __iced_deferrals._fulfill();
            })(function() {
              return __iced_k(_this.ran_keypull = true);
            });
          } else {
            return __iced_k();
          }
        });
      })(this)((function(_this) {
        return function() {
          return cb(err);
        };
      })(this));
    };

    TrackSubSubCommand.prototype.save_their_key = function(cb) {
      var err, k, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      err = null;
      (function(_this) {
        return (function(__iced_k) {
          var _ref3;
          if ((k = (_ref3 = _this.them) != null ? _ref3.key : void 0) != null) {
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.save_their_key"
              });
              k.copy_to_keyring(master_ring()).save(__iced_deferrals.defer({
                assign_fn: (function() {
                  return function() {
                    return err = arguments[0];
                  };
                })(),
                lineno: 187
              }));
              __iced_deferrals._fulfill();
            })(__iced_k);
          } else {
            return __iced_k();
          }
        });
      })(this)((function(_this) {
        return function() {
          return cb(err);
        };
      })(this));
    };

    TrackSubSubCommand.prototype.run = function(cb) {
      var accept, ckres, esc, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      cb = chain_err(cb, this.qring_cleanup.bind(this));
      esc = make_esc(cb, "TrackSubSub::run");
      log.debug("+ run");
      (function(_this) {
        return (function(__iced_k) {
          __iced_deferrals = new iced.Deferrals(__iced_k, {
            parent: ___iced_passed_deferral,
            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
            funcname: "TrackSubSubCommand.run"
          });
          _this.keypull(esc(__iced_deferrals.defer({
            lineno: 199
          })));
          __iced_deferrals._fulfill();
        });
      })(this)((function(_this) {
        return function() {
          (function(__iced_k) {
            __iced_deferrals = new iced.Deferrals(__iced_k, {
              parent: ___iced_passed_deferral,
              filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
              funcname: "TrackSubSubCommand.run"
            });
            User.load_me({
              maybe_secret: true
            }, esc(__iced_deferrals.defer({
              assign_fn: (function(__slot_1) {
                return function() {
                  return __slot_1.me = arguments[0];
                };
              })(_this),
              lineno: 201
            })));
            __iced_deferrals._fulfill();
          })(function() {
            (function(__iced_k) {
              __iced_deferrals = new iced.Deferrals(__iced_k, {
                parent: ___iced_passed_deferral,
                filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                funcname: "TrackSubSubCommand.run"
              });
              _this.check_not_self(esc(__iced_deferrals.defer({
                lineno: 202
              })));
              __iced_deferrals._fulfill();
            })(function() {
              (function(__iced_k) {
                __iced_deferrals = new iced.Deferrals(__iced_k, {
                  parent: ___iced_passed_deferral,
                  filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                  funcname: "TrackSubSubCommand.run"
                });
                User.load({
                  username: _this.args.them,
                  ki64: _this.args.them_ki64,
                  require_public_key: true
                }, esc(__iced_deferrals.defer({
                  assign_fn: (function(__slot_1) {
                    return function() {
                      return __slot_1.them = arguments[0];
                    };
                  })(_this),
                  lineno: 203
                })));
                __iced_deferrals._fulfill();
              })(function() {
                (function(__iced_k) {
                  __iced_deferrals = new iced.Deferrals(__iced_k, {
                    parent: ___iced_passed_deferral,
                    filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                    funcname: "TrackSubSubCommand.run"
                  });
                  _this.them.check_key({
                    secret: false,
                    store: true
                  }, esc(__iced_deferrals.defer({
                    assign_fn: (function() {
                      return function() {
                        return ckres = arguments[0];
                      };
                    })(),
                    lineno: 207
                  })));
                  __iced_deferrals._fulfill();
                })(function() {
                  (function(__iced_k) {
                    if (!ckres.remote) {
                      (function(__iced_k) {
                        __iced_deferrals = new iced.Deferrals(__iced_k, {
                          parent: ___iced_passed_deferral,
                          filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                          funcname: "TrackSubSubCommand.run"
                        });
                        athrow(new E.NoRemoteKeyError("" + _this.args.them + " doesn't have a public key"), esc(__iced_deferrals.defer({
                          lineno: 209
                        })));
                        __iced_deferrals._fulfill();
                      })(__iced_k);
                    } else {
                      (function(__iced_k) {
                        if (!ckres.local) {
                          (function(__iced_k) {
                            __iced_deferrals = new iced.Deferrals(__iced_k, {
                              parent: ___iced_passed_deferral,
                              filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                              funcname: "TrackSubSubCommand.run"
                            });
                            _this.make_quarantined_keyring(esc(__iced_deferrals.defer({
                              lineno: 211
                            })));
                            __iced_deferrals._fulfill();
                          })(__iced_k);
                        } else {
                          return __iced_k();
                        }
                      })(__iced_k);
                    }
                  })(function() {
                    (function(__iced_k) {
                      __iced_deferrals = new iced.Deferrals(__iced_k, {
                        parent: ___iced_passed_deferral,
                        filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                        funcname: "TrackSubSubCommand.run"
                      });
                      _this.them.verify({}, esc(__iced_deferrals.defer({
                        lineno: 213
                      })));
                      __iced_deferrals._fulfill();
                    })(function() {
                      (function(__iced_k) {
                        __iced_deferrals = new iced.Deferrals(__iced_k, {
                          parent: ___iced_passed_deferral,
                          filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                          funcname: "TrackSubSubCommand.run"
                        });
                        TrackWrapper.load({
                          tracker: _this.me,
                          trackee: _this.them
                        }, esc(__iced_deferrals.defer({
                          assign_fn: (function(__slot_1) {
                            return function() {
                              return __slot_1.trackw = arguments[0];
                            };
                          })(_this),
                          lineno: 214
                        })));
                        __iced_deferrals._fulfill();
                      })(function() {
                        (function(__iced_k) {
                          __iced_deferrals = new iced.Deferrals(__iced_k, {
                            parent: ___iced_passed_deferral,
                            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                            funcname: "TrackSubSubCommand.run"
                          });
                          _this.all_prompts(esc(__iced_deferrals.defer({
                            assign_fn: (function() {
                              return function() {
                                return accept = arguments[0];
                              };
                            })(),
                            lineno: 215
                          })));
                          __iced_deferrals._fulfill();
                        })(function() {
                          (function(__iced_k) {
                            if (accept && !ckres.local) {
                              (function(__iced_k) {
                                __iced_deferrals = new iced.Deferrals(__iced_k, {
                                  parent: ___iced_passed_deferral,
                                  filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                                  funcname: "TrackSubSubCommand.run"
                                });
                                _this.save_their_key(esc(__iced_deferrals.defer({
                                  lineno: 218
                                })));
                                __iced_deferrals._fulfill();
                              })(__iced_k);
                            } else {
                              return __iced_k();
                            }
                          })(function() {
                            log.debug("- run");
                            return cb(null);
                          });
                        });
                      });
                    });
                  });
                });
              });
            });
          });
        };
      })(this));
    };

    TrackSubSubCommand.prototype.all_prompts = function(cb) {
      var accept, approve, check, do_remote, err, esc, n_proofs, n_warnings, skp, warnings, ___iced_passed_deferral, __iced_deferrals, __iced_k;
      __iced_k = __iced_k_noop;
      ___iced_passed_deferral = iced.findDeferral(arguments);
      esc = make_esc(cb, "TrackSubSub::all_prompts");
      log.debug("+ TrackSubSub::all_prompts");
      check = this.trackw.skip_remote_check();
      if (check === constants.skip.NONE) {
        log.info("...checking identity proofs");
        skp = false;
      } else {
        log.info("...all remote checks are up-to-date");
        skp = true;
      }
      (function(_this) {
        return (function(__iced_k) {
          __iced_deferrals = new iced.Deferrals(__iced_k, {
            parent: ___iced_passed_deferral,
            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
            funcname: "TrackSubSubCommand.all_prompts"
          });
          _this.check_remote_proofs(skp, esc(__iced_deferrals.defer({
            assign_fn: (function() {
              return function() {
                warnings = arguments[0];
                return n_proofs = arguments[1];
              };
            })(),
            lineno: 237
          })));
          __iced_deferrals._fulfill();
        });
      })(this)((function(_this) {
        return function() {
          n_warnings = warnings.warnings().length;
          (function(__iced_k) {
            if ((approve = _this.trackw.skip_approval()) !== constants.skip.NONE) {
              log.debug("| skipping approval, since remote services & key are unchanged");
              return __iced_k(accept = true);
            } else {
              (function(__iced_k) {
                var _ref3;
                if ((_ref3 = _this.assertions) != null ? _ref3.clean() : void 0) {
                  log.info("Identity accepted due to clean and complete assertions");
                  log.debug("| We can approve due to clean assertions");
                  return __iced_k(accept = true);
                } else {
                  (function(__iced_k) {
                    if (_this.is_batch()) {
                      log.warn("Interactive approval is needed");
                      log.debug("| We needed approval, but we were in batch mode");
                      return __iced_k(accept = false);
                    } else {
                      (function(__iced_k) {
                        __iced_deferrals = new iced.Deferrals(__iced_k, {
                          parent: ___iced_passed_deferral,
                          filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                          funcname: "TrackSubSubCommand.all_prompts"
                        });
                        _this.prompt_ok(n_warnings, n_proofs, esc(__iced_deferrals.defer({
                          assign_fn: (function() {
                            return function() {
                              return accept = arguments[0];
                            };
                          })(),
                          lineno: 252
                        })));
                        __iced_deferrals._fulfill();
                      })(__iced_k);
                    }
                  })(__iced_k);
                }
              })(__iced_k);
            }
          })(function() {
            err = null;
            (function(__iced_k) {
              if (!accept) {
                log.warn("Bailing out; proofs were not accepted");
                return __iced_k(err = new E.CancelError("operation was canceled"));
              } else {
                (function(__iced_k) {
                  if ((check === constants.skip.REMOTE) && (approve === constants.skip.REMOTE)) {
                    return __iced_k(log.info("Nothing to do; tracking is up-to-date"));
                  } else {
                    (function(__iced_k) {
                      if (approve === constants.skip.REMOTE) {
                        return __iced_k(do_remote = false);
                      } else {
                        (function(__iced_k) {
                          __iced_deferrals = new iced.Deferrals(__iced_k, {
                            parent: ___iced_passed_deferral,
                            filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                            funcname: "TrackSubSubCommand.all_prompts"
                          });
                          _this.prompt_track(n_proofs, esc(__iced_deferrals.defer({
                            assign_fn: (function() {
                              return function() {
                                return do_remote = arguments[0];
                              };
                            })(),
                            lineno: 264
                          })));
                          __iced_deferrals._fulfill();
                        })(function() {
                          (function(__iced_k) {
                            if (do_remote) {
                              (function(__iced_k) {
                                __iced_deferrals = new iced.Deferrals(__iced_k, {
                                  parent: ___iced_passed_deferral,
                                  filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                                  funcname: "TrackSubSubCommand.all_prompts"
                                });
                                session.load_and_login(esc(__iced_deferrals.defer({
                                  lineno: 266
                                })));
                                __iced_deferrals._fulfill();
                              })(__iced_k);
                            } else {
                              return __iced_k();
                            }
                          })(__iced_k);
                        });
                      }
                    })(function() {
                      (function(__iced_k) {
                        __iced_deferrals = new iced.Deferrals(__iced_k, {
                          parent: ___iced_passed_deferral,
                          filename: "/home/max/src/keybase/node-client/src/tracksubsub.iced",
                          funcname: "TrackSubSubCommand.all_prompts"
                        });
                        _this.trackw.store_track({
                          do_remote: do_remote
                        }, esc(__iced_deferrals.defer({
                          lineno: 267
                        })));
                        __iced_deferrals._fulfill();
                      })(__iced_k);
                    });
                  }
                })(__iced_k);
              }
            })(function() {
              log.debug("- TrackSubSub::all_prompts");
              return cb(err, accept);
            });
          });
        };
      })(this));
    };

    return TrackSubSubCommand;

  })();

}).call(this);
