// Generated by IcedCoffeeScript 1.7.1-c
(function() {
  var K, SHA256, alloc, box, bufeq_secure, katch, null_hash, obj_extract, pack, purepack, read_base64, unbox, unpack, _ref, _ref1;

  K = require('../const').kb;

  _ref = require('../hash'), alloc = _ref.alloc, SHA256 = _ref.SHA256;

  purepack = require('purepack');

  _ref1 = require('../util'), katch = _ref1.katch, obj_extract = _ref1.obj_extract, bufeq_secure = _ref1.bufeq_secure;

  null_hash = new Buffer(0);

  pack = function(x) {
    return purepack.pack(x, {
      sort_keys: true
    });
  };

  unpack = function(x) {
    return purepack.unpack(x);
  };

  box = function(_arg) {
    var body, hasher, oo, packed, tag;
    tag = _arg.tag, body = _arg.body;
    hasher = SHA256;
    oo = {
      version: K.versions.V1,
      tag: tag,
      body: body,
      hash: {
        type: hasher.type,
        value: null_hash
      }
    };
    packed = pack(oo);
    oo.hash.value = hasher(packed);
    return pack(oo);
  };

  read_base64 = function(raw) {
    var parts;
    parts = (raw.split(/\s+/)).join('');
    return new Buffer(parts, 'base64');
  };

  unbox = function(buf) {
    var h, hasher, hv, oo, t, _ref2;
    oo = unpack(buf);
    if ((hv = oo != null ? (_ref2 = oo.hash) != null ? _ref2.value : void 0 : void 0) == null) {
      throw new Error("missing obj.hash.value");
    }
    oo.hash.value = null_hash;
    hasher = alloc((t = oo.hash.type));
    if (hasher == null) {
      throw new Error("unknown hash algo: " + t);
    }
    h = hasher(pack(oo));
    if (!bufeq_secure(h, hv)) {
      throw new Error("hash mismatch");
    }
    if (oo.version !== K.versions.V1) {
      throw new Error("unknown version");
    }
    return obj_extract(oo, ['tag', 'body']);
  };

  exports.box = box;

  exports.pack = pack;

  exports.unbox = unbox;

  exports.unpack = unpack;

  exports.read_base64 = read_base64;

}).call(this);
